function Fig4()
%% To compute the stability region of du/dz = [(a+ib)|u|^2-l]u
clc;
% close all;

a0 = 1;
b0 = 1;
% gs = [-0.5 -0.1 0 0.2358 0.5 5];
gs = [-0.5 -0.1 0 0.2358 0.5 1.442035];

a = (-6.05:0.1:1.95)*a0;
b = (-4.05:0.1:3.95)*b0;
[A,B] = meshgrid(a,b);
z = A+1i*B;
map1 = ([1 1 1; ([152 251 152])/256]);
% map2 = ([1 1 1; ([255 255 0])/256]);
figure(1);
h1 = gcf;

for ig = 1:length(gs)
    g = gs(ig);
    % Heun's Method
    C = 1+z/2*exp(g);         
    Theta = (1+z.*abs(C).^2.*C*exp(g))*exp(g);
    Mh(ig).m = abs(Theta);   
    disp(min(min(Mh(ig).m))); 
    index = ig+floor((ig-1)/3)*3;
    subplot(4,3,index);
    contourf(a,b,Mh(ig).m,[0 1]), 
%     contour(a,b,Mh(ig).m,[1 1],'r','Linewidth',2); hold on;
	colormap(map1); grid on;
    ttl = sprintf('C = %.5g',g);
    set(gca,'XTick',[-4 -2 0],'YTick',[-2 0 2]);
    xlabel('A','Fontname','Times','FontSize',15);
    ylabel('B','Fontname','Times','FontSize',15);
    title(['(' char(96+index) ') ' ttl],'Fontname','Times','FontSize',15);
    set(gca,'Fontname','Times','FontSize',15);    
    
    % Analytical Solver
    Theta = (power(1-2*A*exp(g),-1/2-1i/2*(B./A)))*exp(g);
    Ma(ig).m = abs(Theta);
    subplot(4,3,index+3);
    contourf(a,b,Ma(ig).m,[0 1]),    
    colormap(map1); grid on;
    set(gca,'XTick',[-4 -2 0],'YTick',[-2 0 2]);
    xlabel('A','Fontname','Times','FontSize',15);
    ylabel('B','Fontname','Times','FontSize',15);
    title(['(' char(96+index+3) ') ' ttl],'Fontname','Times','FontSize',15);
    set(gca,'Fontname','Times','FontSize',15);  
    
end

save SSFT_stability;

filename = 'stability';
set(h1,'Position',[50 50 550 800]);
set(h1,'PaperUnits', 'inches', 'PaperSize', [5.5 8], 'PaperPositionMode', 'manual', 'PaperPosition', [0 0 5.5 8]);
print(h1,strcat(filename,'.pdf'),'-dpdf');
system(sprintf('epstopdf %s --outfile=%s',strcat(filename,'.eps'),strcat(filename,'.pdf')));
end